<?php
// Hier Datenbank-Zugangsdaten anpassen
define('SQLHOST','localhost'); // der URL Deines MySQL-Servers (oft "localhost" aber nicht immer)
define('SQLUSER','datenbankbenutzer'); // Dein MySQL-Benutzer (auch User genannt)
define('SQLPASS','meinpasswort'); // Das zugehoerige Kennwort zu Deinem MySQL-Benutzer
define('SQLDB','meinedatenbank'); // Der Name der Datenbank, die geprueft werden soll.

////////////////////////////////////////
// Ab hier nichts mehr veraendern!
////////////////////////////////////////
$chars=array();
$newchars=array();

for ($i=128;$i<256;$i++)
{
		$char=chr($i);
		$chars[]=utf8_encode($char);
		$newchars[]=$char;
}

if (isset($_GET['c']))
{
	$data=base64_decode($_GET['c']);
	$command=trim(urldecode($data));
	if (strlen($command)>2)
	{
		$param=trim(substr($command,2,strlen($command)-2));
		$command=substr($command,0,2);
	}

	if (strlen($command)==2)
	{
		switch ($command)
		{
			case 'ST':$return_data=show_tables();break;
			case 'GV':$return_data=get_version();break;
			case 'SC':$return_data=get_columns($param);break;
			case 'CC':$return_data=check_chars($param);break;
			case 'RC':$return_data=replace_chars($param);break;
			default: $return_data=mysql_error();break;
		}
		if (is_array($return_data)) echo base64_encode(serialize($return_data));
		else echo base64_encode($return_data);
	}
	else echo 'You are not allowed to access this file!';
}
else echo 'You are not allowed to access this file!';


/////////////////////////////////////////////////////////////////////
// MySQL-Funktionen
/////////////////////////////////////////////////////////////////////

// Verbindung zur Datenbank - bei Erfolg wird die Verbindungskennung
// zurückgeliefert, sonst "false"
function db_con()
{
	$link=mysql_connect(SQLHOST,SQLUSER,SQLPASS);
	if ($link)
	{
		$verbindung=@mysql_select_db(SQLDB);
		if ($verbindung)
		{
			mysql_query('SET NAMES latin1',$link);
			return $link;
		}
		else return false;
	}
	else return false;
};

// Liefert die Ergebnisressource einer MySQL-Abfrage - bei Fehler:false
function sql_query($abfrage)
{
	if ($link=db_con())
	{
		$res=mysql_query($abfrage,$link) or die(mysql_error());
		$ret=$res;
	}
	else $ret=false;
	return $ret;
}

function sql_get($query)
{
	$res=sql_query($query);
	$ret=-1;
	if (!($res===false))
	{
		$ret=array();
		WHILE ($row=mysql_fetch_array($res,MYSQL_ASSOC))
		{
			$ret[]=$row;
		}
	}
	else $ret=mysql_error();
	return $ret;
}

function get_version()
{
	$res=sql_get('SELECT VERSION() AS v');
	return $res;
}

function show_tables()
{
	$res=sql_get('SHOW TABLE STATUS FROM `'.SQLDB.'`');
	return $res;
}

function get_columns($table)
{
	$res=sql_get('SHOW COLUMNS FROM `'.SQLDB.'`.`'.$table.'`');
	return $res;
}

function check_chars_alt($param)
{
	global $chars;
	$params=explode('|',$param);
	$table=$params[0];
	$row=$params[1];
	$sql='SELECT count(*) as summe FROM `'.$table.'` WHERE ';
	$sql.='`'.$row.'` LIKE \'%'.implode('%\' OR `'.$row.'` LIKE \'%',$chars).'%\'';
	$res=sql_get($sql);
	if ($res===false) $ret=mysql_error();
	else $ret=$res;
	return $ret;
}

function check_chars($param)
{
	global $chars,$newchars;
	$params=explode('|',$param);
	$table=$params[0];
	$row=$params[1];
	$anz=sizeof($chars);
	$gefunden=false;
	$f=fopen('mysql_log.txt','a');
	for ($i=0;$i<$anz;$i++)
	{
		$sql='SELECT count(*) as summe FROM `'.$table.'` WHERE ';
		$sql.='`'.$row.'` LIKE \'%'.$chars[$i].'%\'';
		$res=sql_get($sql);
		if ($res===false) $ret=mysql_error();
		else
		{
			if ($res[0]['summe']>0)
			{
				fwrite($f,date("h:i::s",time()).": ".$res[0]['summe']." mal das falsch kodiertes Zeichen $i - ".$newchars[$i]." in Tabelle ".$table." - Spalte ".$row." gefunden.\n\r");
				$gefunden=true;
			}
		}
	}
	fclose($f);
	if ($gefunden) $ret=1; else $ret=0;
	return $ret;
}

function replace_chars($param)
{
	global $chars,$newchars;
	$params=explode('|',$param);
	$table=$params[0];
	$col=$params[1];
	$ret=1;
//$f=fopen('mysql_log.txt','a');
	for ($i=0;$i<sizeof($chars);$i++)
	{
		$sql='UPDATE `'.$table.'` SET `'.$col.'`=REPLACE(`'.$col.'`,\''.$chars[$i].'\',\''.$newchars[$i].'\')';
//fwrite($f,$sql."\r\n");
		$res=sql_query($sql);
		if ($res===false)
		{
			$ret=mysql_error();
//fwrite($f,"-----------   Fehler!!!\r\n");
		}
	}
//fclose($f);
	return $ret;
}

?>